#include "_gen/svc-Account_Interface_Addressing.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_account_interface_addressing_object_info;

struct _McSvcAccountInterfaceAddressingClass {
    GTypeInterface parent_class;
    mc_svc_account_interface_addressing_set_uri_scheme_association_impl set_uri_scheme_association;
};

static void mc_svc_account_interface_addressing_base_init (gpointer klass);

GType
mc_svc_account_interface_addressing_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcAccountInterfaceAddressingClass),
        mc_svc_account_interface_addressing_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcAccountInterfaceAddressing", &info, 0);
    }

  return type;
}

/**
 * mc_svc_account_interface_addressing_set_uri_scheme_association_impl:
 * @self: The object implementing this interface
 * @in_URI_Scheme: const gchar * (FIXME, generate documentation)
 * @in_Association: gboolean  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetURISchemeAssociation on interface org.freedesktop.Telepathy.Account.Interface.Addressing.
 */
static void
mc_svc_account_interface_addressing_set_uri_scheme_association (McSvcAccountInterfaceAddressing *self,
    const gchar *in_URI_Scheme,
    gboolean in_Association,
    DBusGMethodInvocation *context)
{
  mc_svc_account_interface_addressing_set_uri_scheme_association_impl impl = (MC_SVC_ACCOUNT_INTERFACE_ADDRESSING_GET_CLASS (self)->set_uri_scheme_association);

  if (impl != NULL)
    {
      (impl) (self,
        in_URI_Scheme,
        in_Association,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_interface_addressing_implement_set_uri_scheme_association:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetURISchemeAssociation D-Bus method
 *
 * Register an implementation for the SetURISchemeAssociation method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_interface_addressing_implement_set_uri_scheme_association (McSvcAccountInterfaceAddressingClass *klass, mc_svc_account_interface_addressing_set_uri_scheme_association_impl impl)
{
  klass->set_uri_scheme_association = impl;
}

static inline void
mc_svc_account_interface_addressing_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "as", 0, NULL, NULL }, /* URISchemes */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (mc_svc_account_interface_addressing_get_type (),
      &_mc_svc_account_interface_addressing_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Account.Interface.Addressing");
  properties[0].name = g_quark_from_static_string ("URISchemes");
  properties[0].type = G_TYPE_STRV;
  tp_svc_interface_set_dbus_properties_info (MC_TYPE_SVC_ACCOUNT_INTERFACE_ADDRESSING, &interface);

}
static void
mc_svc_account_interface_addressing_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      mc_svc_account_interface_addressing_base_init_once (klass);
    }
}
static const DBusGMethodInfo _mc_svc_account_interface_addressing_methods[] = {
  { (GCallback) mc_svc_account_interface_addressing_set_uri_scheme_association, _mcd_ext_marshal_VOID__STRING_BOOLEAN_POINTER, 0 },
};

static const DBusGObjectInfo _mc_svc_account_interface_addressing_object_info = {
  0,
  _mc_svc_account_interface_addressing_methods,
  1,
"org.freedesktop.Telepathy.Account.Interface.Addressing\0SetURISchemeAssociation\0A\0URI_Scheme\0I\0s\0Association\0I\0b\0\0\0",
"\0\0",
"\0\0",
};


